(* $Id: main.ml,v 1.4 2001/11/11 21:55:50 malekith Exp $ *)

open Gont
;;

let out_ch = stdout
;;

try
  let lexbuf = Lexing.from_channel stdin in
  Ksi.output_header out_ch;
  while true do
    let decl = 
      try 
        (Parser.decl Lexer.token lexbuf) 
      with 
        Parsing.Parse_error -> 
          raise(Syntax_error ((Lexer.get_current_location ()), 
                              "parse error"))
    in
    (* debug "got decl"; *)
    ignore(List.map (Ksi.output_decl out_ch) (codegen decl))
  done
with 
  Eof ->
    Ksi.output_trailer out_ch;
    exit 0
| Syntax_error(loc, msg) ->
    err_msg (loc, msg);
    exit 1
;;


